## libxpertmass 1.1.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
# 3.18.4 in oldstable as of 2024 - 07 - 15
cmake_minimum_required(VERSION 3.18.4)

set(CMAKE_PROJECT_INCLUDE_BEFORE
    ${CMAKE_SOURCE_DIR}/CMakeStuff/ancillary-project-include-before.cmake)

############################################################
############################################################
# Basic information about project

project(XpertMass
  VERSION 1.1.0
  DESCRIPTION "libraries [::Core (non-GUI) and ::GUI) for the MsXpertSuite project."
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/libxpertmass"
  LANGUAGES CXX)

set(LOWCASE_PROJECT_NAME xpertmass)

# VERSION above sets:
# PROJECT_VERSION, <PROJECT-NAME>_VERSION
# PROJECT_VERSION_MAJOR, <PROJECT-NAME>_VERSION_MAJOR
# PROJECT_VERSION_MINOR, <PROJECT-NAME>_VERSION_MINOR
# PROJECT_VERSION_PATCH, <PROJECT-NAME>_VERSION_PATCH


message("\n${BoldGreen}Building version ${PROJECT_VERSION} of \
${PROJECT_NAME} (${CMAKE_PROJECT_DESCRIPTION})${ColourReset}\n")

# Set additional project information
set(COMPANY "MsXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2024 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite.libxpertmass")


include(GNUInstallDirs)
include(FeatureSummary)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldYellow}The devel directory where all the development projects \
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")


set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin) and by the Clang-based code analyzer..
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
  )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "CMAKE_CXX_STANDARD: ON")

message(STATUS "CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}")

#############################################################
# Setting command line compiler definitions:
message(STATUS "${BoldYellow}Setting compiler command line definitions.${ColourReset}")

# We do not want warnings for unknown pragmas:
message("Setting definition -Wno-unknown-pragmas.")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message("Setting definition -Wall -pedantic.")
add_definitions(-Wall -pedantic)
message("Setting definition -Wextra.")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message("Setting definition -Werror.")
  add_definitions(-Werror)
else()
  message("NOT setting definition -Werror.")
endif()

message(STATUS "\nCMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}\n")


option(MXE "Use the cross-compiling environment MXE" OFF)

option(LOCAL_DEV "Use locally developped libpappsomspp" OFF)
option(PAPPSO_LOCAL_DEV "Use locally developped libpappsomspp" OFF)

if(LOCAL_DEV)
  set(PAPPSO_LOCAL_DEV ON)
endif()

message(STATUS "LOCAL_DEV: ${LOCAL_DEV}")
message(STATUS "PAPPSO_LOCAL_DEV: ${PAPPSO_LOCAL_DEV}")

#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX)

  message("UNIX toolchain being selected")

  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-common.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
##################
# BUILD OF THE LIBRARIES

message(STATUS "\n${BoldGreen}Adding subdirectory src for PROJECT: \
${CMAKE_PROJECT_NAME}${ColourReset}\n")
add_subdirectory(src)


#############################################################
######################################
# BUILD OF THE DEVELOPER DOCUMENTATION
option(BUILD_DOC OFF)
if(BUILD_DOC)
add_subdirectory(doc)
endif()


#############################################################
####################
# BUILD OF THE TESTS

if(BUILD_TESTS)

message(STATUS "\n${BoldGreen}Build the tests ${ColourReset}\n")
message("Adding subdirectory tests for PROJECT: ${CMAKE_PROJECT_NAME}")
add_subdirectory(tests)

endif()


#############################################################
################################
# Creation of the source archive
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

set(PARENT_DIR ${CMAKE_SOURCE_DIR}/..)
set(TARBALL_DIR ${PARENT_DIR}/tarballs)

add_custom_target(archive
  cpack -G TGZ --config CPackSourceConfig.cmake &&
  mv ${CMAKE_BINARY_DIR}/${ARCHIVE_FILE_NAME_EXT} ${TARBALL_DIR} &&
  ln -sf ${TARBALL_DIR}/${ARCHIVE_FILE_NAME_EXT}
  ${PARENT_DIR}/${DEBIAN_ORIG_FILE_NAME} &&
  ln -sf ${TARBALL_DIR}/${ARCHIVE_FILE_NAME_EXT}
  ${TARBALL_DIR}/${DEBIAN_ORIG_FILE_NAME}

  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  COMMENT "Creating .tar.gz" VERBATIM)


#-----------------------------------------------------------#
# Summary
#-----------------------------------------------------------#
message("\n\nBegin feature summary")
message("---------------------\n")
feature_summary(FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)
message("---------------------")
message("End feature summary\n\n")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting documentation build configuration for \
${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The output of QDoc will be in ${CMAKE_BINARY_DIR}/html.
# We need to copy the images directory to the build directory.
add_custom_target(doc
  COMMAND /usr/lib/qt6/bin/qdoc developer-documentation.qdocconf --outputdir
${CMAKE_CURRENT_BINARY_DIR}/html
	COMMAND cp -rpf ${CMAKE_CURRENT_LIST_DIR}/images ${CMAKE_CURRENT_BINARY_DIR}/
  WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
  COMMENT "Build of the QDoc-based developer documentation in ${CMAKE_CURRENT_BINARY_DIR}/html")

# For convenience
add_custom_target(documentation DEPENDS doc)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/images
  DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
  DESTINATION ${CMAKE_INSTALL_DOCDIR})

message("")
message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME}  \
developer documentation.${ColourReset}")
message("")

=== src/CMakeLists.txt ===

# Now we can configure the build of both libraries
add_subdirectory(XpertMass)
add_subdirectory(XpertMassGui)

# And finally, we wan export the targets
# The header files for the libraries are installed in the
# corresponding directory's list file.


# Install and export static targets
install(TARGETS Core_static Gui_static
        EXPORT XpertMassStaticTargets
				LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Export static targets
install(EXPORT XpertMassStaticTargets
        FILE XpertMassStaticTargets.cmake
        NAMESPACE XpertMass::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)

export(EXPORT XpertMassStaticTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassStaticTargets.cmake"
       NAMESPACE XpertMass::)

# Install and export shared targets
install(TARGETS Core Gui
        EXPORT XpertMassSharedTargets
				LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
				RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Export shared targets
install(EXPORT XpertMassSharedTargets
        FILE XpertMassSharedTargets.cmake
        NAMESPACE XpertMass::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)

export(EXPORT XpertMassSharedTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/XpertMassSharedTargets.cmake"
       NAMESPACE XpertMass::)

# Generate and install config files
include(CMakePackageConfigHelpers)

if(UNIX)
  configure_package_config_file(${CMAKE_UTILS_PATH}/XpertMassConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)

  write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfigVersion.cmake"
    VERSION "${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}"
    COMPATIBILITY SameMinorVersion)

  install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/XpertMassConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/XpertMass)
endif()

=== tests/CMakeLists.txt ===
message(\n${BoldRed}"Now configuring tests for ${CMAKE_PROJECT_NAME} ${ColourReset}\n")

find_package(Catch2 REQUIRED)


get_property(libmass_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmass_INCLUDE_DIRS)
get_property(libmass_LIBRARIES GLOBAL PROPERTY glob_prop_libmass_LIBRARIES)
message(STATUS "Found libmass at: ${libmass_LIBRARIES} with include dir: ${libmass_INCLUDE_DIRS}")

set(catch2_tests_SRCS
    test_Isotope.cpp
    test_Formula.cpp
)


include_directories(
  ${libmass_INCLUDE_DIRS})


add_executable(catch2-tests
    ${catch2_tests_SRCS}
    ${${TARGET}_QRC_CPP}
)

# Finally actually set the linking dependencies to the executable.
target_link_libraries(catch2-tests

  -Wl,--whole-archive
  ${libmass_LIBRARIES}
  ${libmassgui_LIBRARIES}
  -Wl,--no-whole-archive

  -Wl,--no-as-needed
  PappsoMSpp::Core
  -Wl,--as-needed

  IsoSpec++::IsoSpec++

  Qt6::Core
  Qt6::Xml
  Qt6::Network

  Catch2::Catch2
  Catch2::Catch2WithMain
)

set_property(TARGET catch2-tests PROPERTY CXX_STANDARD 17) # we want C++17

# Add the Catch2-based single binary test file to the CMake's test suite so
# that it gets called using 'make test'. To see the output, add "ARGS=-V" to
# the call.
add_test(catch2-tests "catch2-tests")

=== src/XpertMass/CMakeLists.txt ===
set(CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)
set(CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)


# Whatever the platform, this always works.
find_package(Qt6 COMPONENTS Core Svg Xml Network REQUIRED)


message("\n${BoldGreen}Now configuring library libXpertMass${ColourReset}\n")


########################################################
# Files
set(XpertMass_SRCS
  #
  # Most general features
  globals.cpp
  Prop.cpp
  PropListHolder.cpp
  #
  # The basic chemical features
  Isotope.cpp
  IsotopicData.cpp
  IsotopicDataBaseHandler.cpp
  IsotopicDataLibraryHandler.cpp
  IsotopicDataUserConfigHandler.cpp
  IsotopicDataManualConfigHandler.cpp
  IsotopicClusterGenerator.cpp
  IsotopicClusterShaper.cpp
  PeakCentroid.cpp
  Ponderable.cpp
  ChemicalGroup.cpp
  ChemicalGroupRule.cpp
  Modif.cpp
  ModifSpec.cpp
  Monomer.cpp
  MonomerDictionary.cpp
  MonomerSpec.cpp
  Oligomer.cpp
  Polymer.cpp
  CleaveMotif.cpp
  CleaveRule.cpp
  CleaveSpec.cpp
  Coordinates.cpp
  Formula.cpp
  FragRule.cpp
  FragSpec.cpp
  Ionizable.cpp
  IonizeRule.cpp
  CrossLink.cpp
  CrossLinker.cpp
  CrossLinkerSpec.cpp
  PolChemDef.cpp
  PolChemDefEntity.cpp
  PolChemDefSpec.cpp
  PkaPhPi.cpp
  PkaPhPiDataParser.cpp
  Sequence.cpp
  #
  # The calculation features
  CalcOptions.cpp
  MassPeakShaper.cpp
  MassPeakShaperConfig.cpp
  #
  # Envemind implementation
  Envemind.cpp
  #
  # The Averagine implementation
  Averagine.cpp
  #
  # The network functionality
  MassDataCborBaseHandler.cpp
  MassDataCborMassSpectrumHandler.cpp
  MassDataServer.cpp
  MassDataServerThread.cpp
  MassDataClient.cpp
)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.

# Create a variable to hold the 'includes' directory *relative* to the
# current CMakeLists.txt file.

set(INCLUDES_DIR "${CMAKE_CURRENT_LIST_DIR}/includes/libXpertMass")

file(GLOB XpertMass_HEADERS ${INCLUDES_DIR}/*.hpp)
list(APPEND XpertMass_HEADERS ${INCLUDES_DIR}/exportimportconfig.h)
message(STATUS "Included the header files from ${INCLUDES_DIR}: \n\
  ${XpertMass_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

add_library(compiler_flags INTERFACE)
target_compile_features(compiler_flags INTERFACE cxx_std_11)

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the library, because we have defined the sources.

#############################################################
# Build the static lib
add_library(Core_static STATIC
  ${XpertMass_HEADERS}
  ${XpertMass_SRCS}
  ${PLATFORM_SPECIFIC_SOURCES})

set_target_properties(Core_static
  PROPERTIES OUTPUT_NAME XpertMass
  LINK_FLAGS "-Wl,--whole-archive")

target_link_libraries(Core_static

  PappsoMSpp::Core

  IsoSpec++::IsoSpec++

  Qt6::Core
  Qt6::Xml
  Qt6::Network)

# The install interface that is ${prefix}/include
# These include directories are for users of this lib.
target_include_directories(Core_static
PUBLIC
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# These include directories are for building of this lib.
target_include_directories(Core_static
PUBLIC
  $<BUILD_INTERFACE:${INCLUDES_DIR}>)

get_target_property(Core_static_INCLUDES Core_static INCLUDE_DIRECTORIES)

message(STATUS "Core_static_INCLUDES: \
${Core_static_INCLUDES}")

install(TARGETS Core_static
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})


#############################################################
# Build the shared lib
add_library(Core SHARED
  ${XpertMass_HEADERS}
  ${XpertMass_SRCS}
  ${PLATFORM_SPECIFIC_SOURCES})

set_target_properties(Core
  PROPERTIES OUTPUT_NAME XpertMass
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
  LINK_FLAGS "-Wl,--no-as-needed"
  POSITION_INDEPENDENT_CODE ON)

target_link_libraries(Core

  PappsoMSpp::Core

  IsoSpec++::IsoSpec++

  Qt6::Core
  Qt6::Xml
  Qt6::Network
)

# The install interface that is ${prefix}/include
# These include directories are for users of this lib.
target_include_directories(Core
PUBLIC
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# These include directories are for building of this lib.
target_include_directories(Core
PUBLIC
  $<BUILD_INTERFACE:${INCLUDES_DIR}>)

get_target_property(Core_INCLUDES Core INCLUDE_DIRECTORIES)

message(STATUS "Core_INCLUDES: \
${Core_INCLUDES}")

target_compile_definitions(Core PRIVATE "EXPORT_LIB_SYMBOLS")

# This is to avoid the "include_next(math.h) file not found" error.
if(WIN32)
  set_target_properties(Core_static
  PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
  set_target_properties(Core
  PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
endif()


#############################################################
# Common installation configuration

install(FILES ${XpertMass_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libXpertMass")

message("")
message(STATUS "${BoldGreen}Finished configuration of libXpertMass.${ColourReset}")
message("")

=== src/XpertMassGui/CMakeLists.txt ===
set(CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)
set(CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)


# Whatever the platform, this always works.
find_package(Qt6 COMPONENTS Widgets Core Gui PrintSupport Svg Xml Network REQUIRED)


message("\n${BoldGreen}Now configuring library libXpertMassGui${ColourReset}\n")


########################################################
# Files
set(XpertMassGui_SRCS
  #
  ColorSelector.cpp
  IsotopicClusterGeneratorDlg.cpp
  IsotopicClusterShaperDlg.cpp
  IsotopicDataTableView.cpp
  IsotopicDataTableViewModel.cpp
  MassDataClientServerConfigDlg.cpp
  MassPeakShaperConfigDlg.cpp
  MassPeakShaperConfigWidget.cpp)

set(XpertMassGui_UIS
  ui/IsotopicClusterGeneratorDlg.ui
  ui/MassPeakShaperConfigDlg.ui
  ui/IsotopicClusterShaperDlg.ui
  ui/ElementGroupBoxWidget.ui
  ui/MassDataClientServerConfigDlg.ui
  ui/MassPeakShaperConfigWidget.ui
)

qt6_wrap_ui(XpertMassGui_UIS_H ${XpertMassGui_UIS})

qt6_add_resources(XpertMassGui_QRC_CPP ressources.qrc)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.

# Create a variable to hold the 'includes' directory *relative* to the
# current CMakeLists.txt file.

set(INCLUDES_DIR "${CMAKE_CURRENT_LIST_DIR}/includes/libXpertMassGui")
# Use the directory as is (see below, will be modified)
# to create the list of header files.
file(GLOB XpertMassGui_HEADERS ${INCLUDES_DIR}/*.hpp)
list(APPEND XpertMassGui_HEADERS ${INCLUDES_DIR}/exportimportconfig.h)
message(STATUS "Included the header files from ${INCLUDES_DIR}: \n\
  ${XpertMassGui_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the library, because we have defined the sources.

#############################################################
# Build the static lib
add_library(Gui_static STATIC
  ${XpertMassGui_HEADERS}
  ${XpertMassGui_SRCS}
  ${XpertMassGui_UIS_H}
  ${XpertMassGui_QRC_CPP}
  ${PLATFORM_SPECIFIC_SOURCES})

set_target_properties(Gui_static
  PROPERTIES OUTPUT_NAME XpertMassGui
  LINK_FLAGS "-Wl,--whole-archive")

target_link_libraries(Gui_static

  PappsoMSpp::Core

  IsoSpec++::IsoSpec++

  Qt6::Core
  Qt6::Gui
  Qt6::Widgets
  Qt6::PrintSupport
  Qt6::Svg
  Qt6::Xml
  Qt6::Network

  Core_static)

# The install interface that is ${prefix}/include
target_include_directories(Gui_static PUBLIC
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# These include directories are for building of this lib.
target_include_directories(Gui_static PUBLIC
  $<BUILD_INTERFACE:${INCLUDES_DIR}>)
target_include_directories(Gui_static PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
target_include_directories(Gui_static PUBLIC
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/XpertMass/includes>)

get_target_property(Gui_static_INCLUDES Gui_static INCLUDE_DIRECTORIES)

message(STATUS "Gui_static_INCLUDES: \
${Gui_static_INCLUDES}")

install(TARGETS Gui_static
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

#############################################################
# Build the shared lib
add_library(Gui SHARED
  ${XpertMassGui_HEADERS}
  ${XpertMassGui_SRCS}
  ${XpertMassGui_UIS_H}
  ${${TARGET}_QRC_CPP}
  ${PLATFORM_SPECIFIC_SOURCES})

set_target_properties(Gui
  PROPERTIES OUTPUT_NAME XpertMassGui
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
  LINK_FLAGS "-Wl,--no-as-needed"
)

target_link_libraries(Gui

  PappsoMSpp::Core

  IsoSpec++::IsoSpec++

  Qt6::Core
  Qt6::Gui
  Qt6::Widgets
  Qt6::PrintSupport
  Qt6::Svg
  Qt6::Xml
  Qt6::Network

  Core)

# The install interface that is ${prefix}/include
# These include directories are for users of this lib.
target_include_directories(Gui PUBLIC
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# These include directories are for building of this lib.
target_include_directories(Gui PUBLIC
  $<BUILD_INTERFACE:${INCLUDES_DIR}>)
target_include_directories(Gui PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
target_include_directories(Gui PUBLIC
  $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/XpertMass/includes>)

get_target_property(Gui_INCLUDES Gui INCLUDE_DIRECTORIES)

message(STATUS "Gui_INCLUDES: \
${Gui_INCLUDES}")

target_compile_definitions(Gui PRIVATE "EXPORT_LIB_SYMBOLS")


# This is to avoid the "include_next(math.h) file not found" error.
if(WIN32)
  set_target_properties(Gui_static
  PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
  set_target_properties(Gui
  PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
endif()


#############################################################
# Common installation configuration

install(FILES ${XpertMassGui_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libXpertMassGui")

# See parent directory's list file.

message(STATUS "CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")
message("")
message(STATUS "${BoldGreen}Finished configuration of libXpertMassGui.${ColourReset}")
message("")

=== debian/changelog ===
libxpertmass (1.1.0-1) unstable; urgency=medium

  * Upstream release with build system improvements.

  * Fix bug due to trying to find file up of the source directory
    (thanks to 	Adrian Bunk <bunk@debian.org>, Closes: #1077251).

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 28 Jul 2024 19:27:58 +0200

libxpertmass (1.0.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1076552).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 17 Jul 2024 22:45:46 +0200

=== debian/control ===
Source: libxpertmass
Section: libs
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-exec,
 d-shlibs,
 qt6-base-dev,
 libqt6core5compat6-dev,
 libqt6svg6-dev,
 qt6-documentation-tools,
 qt6-base-doc-html,
 libisospec++-dev (>=2.2.1),
 libpappsomspp-dev (>= 0.9.38),
 catch2
Standards-Version: 4.7.0
Homepage: http://www.msxpertsuite.org/libxpertmass/
Vcs-Browser: https://salsa.debian.org/debichem-team/libxpertmass
Vcs-Git: https://salsa.debian.org/debichem-team/libxpertmass.git

Package: libxpertmass-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxpertmass1 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libxpertmass-doc
Description: C++ mass spectrometry libraries (non-GUI development files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the development files for the libXpertMass library.


Package: libxpertmass1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ mass spectrometry libraries (non-GUI runtime files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the runtime files for the libXpertMass library.

Package: libxpertmassgui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxpertmass-dev (= ${binary:Version}),
 libxpertmassgui1 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libxpertmass-doc
Description: C++ mass spectrometry libraries (GUI development files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the development files for the libXpertMassGui library.

Package: libxpertmassgui1
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ mass spectrometry libraries (GUI runtime files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the runtime files for the libXpertMassGui library.

Package: libxpertmass-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Description: C++ mass spectrometry libraries (documentation files)
 The libXpertMass and the libXpertMassGui shared libraries are designed
 to enshrine the non-GUI and the GUI functionalities needed by the
 following two mass spectrometry projects:
 .
  * msXpertSuite/massXpert2;
  * msXpertSuite/mineXpert2.
 .
 libXpertMass contains abstractions for all the chemical entities required
 to fully characterize a polymer chemistry definition, as shown below:
 .
  * Isotope
  * IsotopicData
  * Formula
  * Monomer
  * Oligomer
  * Polymer
  * Modif
  * CrossLinker
  * CrossLink
  * Aqueous chemical reactions (cleavages, enzymatic and non-enzymatic)
  * Gas-phase chemical reactions (fragmentations, with a sophisticated
    grammar to describe complex fragmentation patterns)
  * Isotopic cluster modelling/calculations for any chemical entity
    representable by an element composition formula and a charge.
 .
 libXpertMassGui contains classes useful:
 .
  * to display and manage isotopic data,
  * to configure isotopic cluster calculations,
  * to configure mass peak shaping processes (GAUSSIAN and LORENTZIAN),
  * to configure network communications between massXpert2 and mineXpert2.
 .
 This package ships the developer documentation for the two libraries.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
  export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
endif

%:
	dh $@ --buildsystem=cmake

# For automating the dh-exec stuff.
# Do not forget to include /usr/share/dpkg/pkg-info.mk above
export LIBXPERTMASS_VERSION=$(DEB_VERSION_UPSTREAM)
export LIBXPERTMASS_SOVERSION=1


ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  CMAKE_EXTRA_TESTING_ARGS = -DMAKE_TESTS=1 -DBUILD_TESTING=1
endif

override_dh_auto_configure:

	echo "LIBXPERTMASS_VERSION: $(LIBXPERTMASS_VERSION)"
	echo "LIBXPERTMASS_SOVERSION $(LIBXPERTMASS_SOVERSION)"

	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_SKIP_RPATH=OFF \
		-DBUILD_DOC=ON \
		$(CMAKE_EXTRA_TESTING_ARGS)

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- doc
	find -type d -empty -delete
